Encodes files using Zeng Guard Encoder

This is very closely based on the ANT class of the same name.

author | Petr Rybak
version | $Id: cdbb2883ab70c650896a465a872b3da30f13eb00 $
package | phing.tasks.ext.zendguard
since | 2.4.3
copyright | 2001,2002 THYRELL. All rights reserved

### Methods

## Create instance; set fileset to new FileSet.

    __construct()

Inherited

inherited_from | \MatchingTask::__construct()

## Add a new selector into this container.

    appendSelector(\FileSelector $selector) : void

Inherited

inherited_from | \MatchingTask::appendSelector()

### Parameters

#### $selector

`\FileSelector`

the new selector to add

## add an "And" selector entry on the selector list

    createAnd() : \AndSelector

Inherited

inherited_from | \MatchingTask::createAnd()

### Returns

`\AndSelector`

## add a contains selector entry on the selector list

    createContains() : \ContainsSelector

Inherited

inherited_from | \MatchingTask::createContains()

### Returns

`\ContainsSelector`

## add an extended selector entry on the selector list

    createCustom() : \ExtendSelector

Inherited

inherited_from | \MatchingTask::createCustom()

### Returns

`\ExtendSelector`

## add a selector date entry on the selector list

    createDate() : \DateSelector

Inherited

inherited_from | \MatchingTask::createDate()

### Returns

`\DateSelector`

## add a depends selector entry on the selector list

    createDepend() : \DependSelector

Inherited

inherited_from | \MatchingTask::createDepend()

### Returns

`\DependSelector`

## add a depth selector entry on the selector list

    createDepth() : \DepthSelector

Inherited

inherited_from | \MatchingTask::createDepth()

### Returns

`\DepthSelector`

## add a name entry on the exclude list

    createExclude() : \PatternSetNameEntry

Inherited

inherited_from | \MatchingTask::createExclude()

### Returns

`\PatternSetNameEntry`

## add a name entry on the include files list

    createExcludesFile() : \PatternSetNameEntry

Inherited

inherited_from | \MatchingTask::createExcludesFile()

### Returns

`\PatternSetNameEntry`

## Add a new fileset.

    createFileSet() : \FileSet

### Returns

`\FileSet`

## add a selector filename entry on the selector list

    createFilename() : \FilenameSelector

Inherited

inherited_from | \MatchingTask::createFilename()

### Returns

`\FilenameSelector`

## add a name entry on the include list

    createInclude() : \PatternSetNameEntry

Inherited

inherited_from | \MatchingTask::createInclude()

### Returns

`\PatternSetNameEntry`

## add a name entry on the include files list

    createIncludesFile() : \PatternSetNameEntry

Inherited

inherited_from | \MatchingTask::createIncludesFile()

### Returns

`\PatternSetNameEntry`

## add a majority selector entry on the selector list

    createMajority() : \MajoritySelector

Inherited

inherited_from | \MatchingTask::createMajority()

### Returns

`\MajoritySelector`

## add a "None" selector entry on the selector list

    createNone() : \NoneSelector

Inherited

inherited_from | \MatchingTask::createNone()

### Returns

`\NoneSelector`

## add a "Not" selector entry on the selector list

    createNot() : \NotSelector

Inherited

inherited_from | \MatchingTask::createNot()

### Returns

`\NotSelector`

## add an "Or" selector entry on the selector list

    createOr() : void

Inherited

inherited_from | \MatchingTask::createOr()

## add a set of patterns

    createPatternSet() : \PatternSet

Inherited

inherited_from | \MatchingTask::createPatternSet()

### Returns

`\PatternSet`

## add a present selector entry on the selector list

    createPresent() : \PresentSelector

Inherited

inherited_from | \MatchingTask::createPresent()

### Returns

`\PresentSelector`

## add a "Select" selector entry on the selector list

    createSelector() : \SelectSelector

Inherited

inherited_from | \MatchingTask::createSelector()

### Returns

`\SelectSelector`

## add a selector size entry on the selector list

    createSize() : \SizeSelector

Inherited

inherited_from | \MatchingTask::createSize()

### Returns

`\SizeSelector`

## Returns the textual description of the task

    getDescription() : string

Inherited

inherited_from | \Task::getDescription()
inherited_from | \MatchingTask::getDescription()

### Returns

`string`The text description of the task

## Returns the location within the buildfile this task occurs.

    getLocation() : \Location

Inherited

Used by BuildException to give detailed error messages.

inherited_from | \Task::getLocation()
inherited_from | \MatchingTask::getLocation()

### Returns

`\Location`The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

Inherited

inherited_from | \Task::getOwningTarget()
inherited_from | \MatchingTask::getOwningTarget()

### Returns

`\Target`The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \Task::getProject()
inherited_from | \MatchingTask::getProject()

### Returns

`\Project`Reference to current porject object

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

Inherited

inherited_from | \Task::getRuntimeConfigurableWrapper()
inherited_from | \MatchingTask::getRuntimeConfigurableWrapper()

### Returns

`\RuntimeConfigurable`The wrapper object used by this task

## Returns the set of selectors as an array.

    getSelectors(\Project $p) : array

Inherited

inherited_from | \MatchingTask::getSelectors()

### Parameters

#### $p

### Returns

`array`FileSelector[] An array of selectors in this container

## Returns the name of task, used only for log messages

    getTaskName() : string

Inherited

inherited_from | \Task::getTaskName()
inherited_from | \MatchingTask::getTaskName()

### Returns

`string`Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

Inherited

inherited_from | \Task::getTaskType()
inherited_from | \MatchingTask::getTaskType()

### Returns

`string`The type of this task (XML Tag)

## Indicates whether there are any selectors here.

    hasSelectors() : boolean

Inherited

inherited_from | \MatchingTask::hasSelectors()

### Returns

`boolean`Whether any selectors are in this container

## Called by the parser to let the task initialize properly.

    init()

Inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

inherited_from | \Task::init()
inherited_from | \MatchingTask::init()

### Exceptions

`\BuildException` |

## Provides a project level log event to the task.

    log(string $msg, integer $level)

Inherited

see | \global\BuildEvent
see | \global\BuildListener
inherited_from | \Task::log()
inherited_from | \MatchingTask::log()

### Parameters

#### $msg

`string`

The message to log

#### $level

`integer`

The priority of the message

## Do the work

    main()

This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running phing target1 target2 will run all tasks in target3 twice.

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

### Exceptions

`\BuildException` |

## Configure this task if it hasn't been done already.

    maybeConfigure()

Inherited

inherited_from | \Task::maybeConfigure()
inherited_from | \MatchingTask::maybeConfigure()

## Perfrom this task

    perform()

Inherited

inherited_from | \Task::perform()
inherited_from | \MatchingTask::perform()

## Gives the count of the number of selectors in this container

    selectorCount() : int

Inherited

inherited_from | \MatchingTask::selectorCount()

### Returns

`int`The number of selectors in this container

## Returns an enumerator for accessing the set of selectors.

    selectorElements() : \an

Inherited

inherited_from | \MatchingTask::selectorElements()

### Returns

`\an`enumerator that goes through each of the selectors

## setAspTags()

    setAspTags($value)

### Parameters

#### $value

## Sets case sensitivity of the file system

    setCaseSensitive(boolean $isCaseSensitive) : void

Inherited

inherited_from | \MatchingTask::setCaseSensitive()

### Parameters

#### $isCaseSensitive

`boolean`

"true"|"on"|"yes" if file system is case sensitive, "false"|"off"|"no" when not.

## Sets whether default exclusions should be used or not.

    setDefaultexcludes(boolean $useDefaultExcludes)

Inherited

inherited_from | \MatchingTask::setDefaultexcludes()

### Parameters

#### $useDefaultExcludes

`boolean`

"true"|"on"|"yes" when default exclusions should be used, "false"|"off"|"no" when they shouldn't be used.

## setDeleteSource()

    setDeleteSource($value)

### Parameters

#### $value

## Sets a textual description of the task

    setDescription(string $desc)

Inherited

inherited_from | \Task::setDescription()
inherited_from | \MatchingTask::setDescription()

### Parameters

#### $desc

`string`

The text describing the task

## setEncodedOnly()

    setEncodedOnly($value)

### Parameters

#### $value

## Sets the set of exclude patterns.

    setExcludes(string $excludes)

Inherited

Patterns may be separated by a comma or a space.

inherited_from | \MatchingTask::setExcludes()

### Parameters

#### $excludes

`string`

the string containing the exclude patterns

## Sets the name of the file containing the includes patterns.

    setExcludesfile(\PhingFile $excludesfile) : void

Inherited

inherited_from | \MatchingTask::setExcludesfile()

### Parameters

#### $excludesfile

`\PhingFile`

A string containing the filename to fetch the include patterns from.

## setExpires()

    setExpires($value)

### Parameters

#### $value

## Sets whether or not symbolic links should be followed.

    setFollowSymlinks(boolean $followSymlinks) : void

Inherited

inherited_from | \MatchingTask::setFollowSymlinks()

### Parameters

#### $followSymlinks

`boolean`

whether or not symbolic links should be followed

## setForceEncode()

    setForceEncode($value)

### Parameters

#### $value

## setIgnoreFileModes()

    setIgnoreFileModes($value)

### Parameters

#### $value

## Sets the set of include patterns.

    setIncludes(string $includes) : void

Inherited

Patterns may be separated by a comma or a space.

inherited_from | \MatchingTask::setIncludes()

### Parameters

#### $includes

`string`

the string containing the include patterns

## Sets the name of the file containing the includes patterns.

    setIncludesfile(\PhingFile $includesfile) : void

Inherited

inherited_from | \MatchingTask::setIncludesfile()

### Parameters

#### $includesfile

`\PhingFile`

A string containing the filename to fetch the include patterns from.

## setLicenseProduct()

    setLicenseProduct($value)

### Parameters

#### $value

## Sets the location within the buildfile this task occurs.

    setLocation(\Location $location)

Inherited

Called by the parser to set location information.

inherited_from | \Task::setLocation()
inherited_from | \MatchingTask::setLocation()

### Parameters

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## setNoHeader()

    setNoHeader($value)

### Parameters

#### $value

## setObfuscationLevel()

    setObfuscationLevel($value)

### Parameters

#### $value

## setOptMask()

    setOptMask($value)

### Parameters

#### $value

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

Inherited

inherited_from | \Task::setOwningTarget()
inherited_from | \MatchingTask::setOwningTarget()

### Parameters

#### $target

`\Target`

Reference to owning target

## setPrivateKeyPath()

    setPrivateKeyPath($value)

### Parameters

#### $value

## setProductName()

    setProductName($value)

### Parameters

#### $value

## References the project to the current component.

    setProject(\Project $project)

Inherited

see | \global\ProjectComponent::setProject()
inherited_from | \MatchingTask::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## setPrologFile()

    setPrologFile($value)

### Parameters

#### $value

## setRenameSourceExt()

    setRenameSourceExt($value)

### Parameters

#### $value

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

Inherited

inherited_from | \Task::setRuntimeConfigurableWrapper()
inherited_from | \MatchingTask::setRuntimeConfigurableWrapper()

### Parameters

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## setShortTags()

    setShortTags($value)

### Parameters

#### $value

## setSignProduct()

    setSignProduct($value)

### Parameters

#### $value

## Sets the name of this task for log messages

    setTaskName(string $name) : string

Inherited

inherited_from | \Task::setTaskName()
inherited_from | \MatchingTask::setTaskName()

### Parameters

#### $name

`string`

### Returns

`string`A string representing the name of this task for log

## Sets the type of the task.

    setTaskType(string $name)

Inherited

Usually this is the name of the XML tag

inherited_from | \Task::setTaskType()
inherited_from | \MatchingTask::setTaskType()

### Parameters

#### $name

`string`

The type of this task (XML Tag)

## setUseCrypto()

    setUseCrypto($value)

### Parameters

#### $value

## TASK PROPERTIES SETTERS

    setZendEncoderPath($value)

### Parameters

#### $value

## Encodes a file using currently defined Zend Guard settings

    encodeFile(string $filePath)

### Parameters

#### $filePath

`string`

Path to the encoded file

## Returns the directory scanner needed to access the files to process.

    getDirectoryScanner(\PhingFile $baseDir) : \DirectoryScanner

Inherited

inherited_from | \MatchingTask::getDirectoryScanner()

### Parameters

#### $baseDir

### Returns

`\DirectoryScanner`

## Accessor for the implict fileset.

    getImplicitFileSet() : \FileSet

Inherited

inherited_from | \MatchingTask::getImplicitFileSet()

### Returns

`\FileSet`

## Returns a name

    getRegisterSlot(string $slotName)

Inherited

inherited_from | \Task::getRegisterSlot()
inherited_from | \MatchingTask::getRegisterSlot()

### Parameters

#### $slotName

`string`

## Prepares the main part of the command that will be used to encode the given file(s).

    prepareEncoderCommand()

## Verifies that the configuration is correct

    verifyConfiguration()

### Exceptions

`\BuildException` |

### Properties

##

    $aspTags : bool

(default: off). On or off must be specified as an argument when using this option. The default, when this option is not used in the command-line, is - off

##

    $deleteSource : bool

This option has no option parameter. When this option is use, do not use the output_file parameter.

Warning: To avoid permanent loss of non-encoded scripts, make a backup. Deleted files cannot be restored or recovered and will be permanently deleted with this option. If you are unsure about deleting the source files, use the ––rename-source option instead

##

    $description : string

Inherited

inherited_from | \Task::$$description
inherited_from | \MatchingTask::$$description

##

    $encodeCommand

##

    $encodedOnly : bool

This option generates files that work exclusively with associated encoded files. Associated encoded files are those generated by the same company. Files that do not share the same encoded company association cannot call these files

##

    $expires : string

Date is in yyyy-mm-dd format.

##

    $fileset : \FileSet

Inherited

inherited_from | \MatchingTask::$$fileset

##

    $filesets

##

    $forceEncode : bool

(NOT recommended!)

##

    $ignoreFileModes : bool

##

    $licenseProduct : bool

If enabled, productName must be defined.

##

    $location : \Location

Inherited

inherited_from | \Task::$$location
inherited_from | \MatchingTask::$$location

##

    $noHeader : bool

Encoded files generated with this option will not display a meaningful error when loaded by PHP that doesn't have the Zend Optimizer properly installed. Using this option saves approximately 1.5KB for every encoded file. Do not use it unless disk space constraints are critica

##

    $obfuscationLevel : int

Defaults to 0 (no obfuscation).

##

    $optMask : int

(default value: [+++++++]) opt_mask is an integer representing a bit-mask. The default value enables all of the optimization passes. Each optimization pass of the Zend Optimizer can be turned on or off based on the mask entered

##

    $privateKeyPath : string

##

    $productName : string

Must be defined if licenseProduct or signProduct is set to 1

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \Task::$$project
inherited_from | \MatchingTask::$$project

##

    $prologFile : string

##

    $renameSourceExt : string

If specified deleteSource will be automatically disabled.

##

    $shortTags : bool

On or off must be specified as an argument when using this option. The default, when option is not used in the command-line, is - on

##

    $signProduct : bool

##

    $target : \Target

Inherited

inherited_from | \Task::$$target
inherited_from | \MatchingTask::$$target

##

    $taskName : string

Inherited

inherited_from | \Task::$$taskName
inherited_from | \MatchingTask::$$taskName

##

    $taskType : string

Inherited

inherited_from | \Task::$$taskType
inherited_from | \MatchingTask::$$taskType

##

    $useCrypto : bool

##

    $useDefaultExcludes : boolean

Inherited

inherited_from | \MatchingTask::$$useDefaultExcludes

##

    $wrapper : \RuntimeConfigurable

Inherited

inherited_from | \Task::$$wrapper
inherited_from | \MatchingTask::$$wrapper

##

    $zendEncoderPath : string